/*
	Aron Roxana Elena
	332CB
	Whack The Weasel
*/

#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "pitches.h"    

#define LEVEL1 0
#define LEVEL2 5
#define LEVEL3 15
#define WIN 30
#define LOSE 5

uint16_t notes[] = {c,c,d,c,f,e,c,c,d};

uint16_t loser_notes[] = {3822, 3606, 3404, 3214, 3032, 2862, 2702, 2550, 2406, 2272, 2144, 2024,
                    1911, 1803, 1702, 1607, 1516, 1431, 1351, 1275, 1203, 1136, 1072, 1012, 952, 892, 800, 700};
uint16_t loser_durations[] = {12,12,12,14, 16,16,14,14, 12,16,14,14, 12,12,12,12, 14,14,14,14, 9,9,9,9, 14,12,11,9, 7,7,7,7, 6, 4,4, 12};

uint16_t winner_notes[] = {NOTE_G4, NOTE_G4, NOTE_B4, NOTE_D5, NOTE_E5, NOTE_F5, NOTE_E5, NOTE_D5, NOTE_CS5, NOTE_D5, NOTE_G4, 
							NOTE_G4, NOTE_B4, NOTE_D5, NOTE_E5, NOTE_F5, NOTE_E5, NOTE_D5, NOTE_B4, NOTE_G4};
uint16_t winner_durations[] = {8, 4, 4, 2, 8, 8, 8, 8, 8, 2, 8, 4, 4, 2, 8, 8, 8, 8, 8, 2};


/* 
	led-urile sunt conectate la porturile A0-A7 + portul B0
	butoanele sunt conectate la porturile C1-C7 + porturile B1, B2
	led-urile de dificultate sunt conectate la porturile D0, D1, B3 (B3 in loc de D2)
	butonul start game este conectat la portul D6 ( D6 in loc de D3)
	(am facut inlocuirile pentru a lasa pinii D2 si D3 liberi)
	buzzer-ul este conectat la portul D5

*/


/* initializeaza timer-ul 1 */
void timer1_init()
{
    /* Se foloseste modul Fast PWM cu prag pe ICR1 si 
     * prescaler 1024 */
    TCCR1B |= (1 << CS10) | (1 << WGM13) | (1 << WGM12);
    TCCR1A |= (1 << WGM11) | (1 << COM1B1) | (1 << COM1A1);
    
    /* valoarea initiala a pragului */
    ICR1 = 60000;
    OCR1B = ICR1 / 4;
    OCR1A = ICR1 / 2;
}

// melodie pentru trecerea dintre nivele
void between_levels_play() {
	timer1_init();
	
	int i;
	for(i=0; i<9; i++) {
		ICR1 = 16000000UL / notes[i];
		OCR1A = ICR1 / 2; 
		_delay_ms(60);
	}
	ICR1 = 0;
}
// melodie pentru castigator
void winner_play() {

	timer1_init();
	uint8_t fun = 0;
	int i = 0;
	int size = 20;
	
	while(i < size * 3) {
		ICR1 = 16000000UL / winner_notes[fun] - 1;
		OCR1A = ICR1 / 2; 
			
		int16_t present_duration = winner_durations[fun];
		while (present_duration--) _delay_ms(30);
		fun = (fun + 1) % size;
		i++;
	}
	ICR1 = 16000000UL / 9000;
	OCR1A = ICR1 / 2; 
	_delay_ms(60);
	ICR1 = 16000000UL / 6800;
	OCR1A = ICR1 / 2;
	_delay_ms(60);
	
	ICR1 = 0;
}

// melodie pentru pierzator
void loser_play() {

	timer1_init();
	uint8_t fun = 0;
	int i = 0;
	int size = 28;
	
	while(i < size) {
		ICR1 = 16000000UL / loser_notes[fun] - 1;
		OCR1A = ICR1 / 2; 
			
		int16_t present_duration=  loser_durations[fun];
		while (present_duration--) _delay_ms(25);
		fun = (fun + 1) % size;
		i++;
	}
	ICR1 = 16000000UL / 9000;
	OCR1A = ICR1 / 2; 
	_delay_ms(60);
	ICR1 = 16000000UL / 6800;
	OCR1A = ICR1 / 2;
	_delay_ms(60);
	
	ICR1 = 0;
}

// melodie pentru apasare buton gresit
void play_mistake() {
	timer1_init();
	
	ICR1 = 16000000UL / 9000;
	OCR1A = ICR1 / 2; 
	_delay_ms(60);
	ICR1 = 16000000UL / 6800;
	OCR1A = ICR1 / 2;
	_delay_ms(60);
	
	ICR1 = 0;

}

// functie pentru aprinderea unui led random
int choose_led() {

	int random_led = rand() % 9;
	
	// stingem orice led aprins anterior
	PORTA = 0x00;
	PORTB &= ~(1 << PB0);
	_delay_ms(100);
	
	// aprindem un led ales random
	if(random_led == 0){
		PORTA |= (1 << PA0);
		return random_led;
	}
	if(random_led == 1){
		PORTA |= (1 << PA1);
		return random_led;
	}
	if(random_led == 2){
		PORTA |= (1 << PA2);
		return random_led;
	}
	if(random_led == 3){
		PORTA |= (1 << PA3);
		return random_led;
	}
	if(random_led == 4){
		PORTA |= (1 << PA4);
		return random_led;
	}
	if(random_led == 5){
		PORTA |= (1 << PA5);
		return random_led;
	}
	if(random_led == 6){
		PORTA |= (1 << PA6);
		return random_led;
	}
	if(random_led == 7){
		PORTA |= (1 << PA7);
		return random_led;
	}
	if(random_led == 8){
		PORTB |= (1 << PB0);
		return random_led;
	}
	
	return random_led;

}

// functie care verifica daca s-a apasat butonul corect
// returneaza 1 daca s-a apasat butonul corect si 0 in caz contrar
int push_button(int led, int level) {
	long time = 0;
	if(level == 1)
		time = 800000;
	if(level == 2)
		time = 450000;
	if(level == 3)
		time = 250000;
	
	while(1){
		
		if(--time == 0) {
		
			return 0; // nu s-a apasat niciun buton in timp necesar
		}			
		
		if((PINC & (1 << PC6)) == 0) {		
			while((PINC & (1 << PC6)) == 0);
			if(led == 0)	// s-a apasat butonul corect
				return 1;				
			else{ // s-a apasat un buton gresit
				time = 1;
				continue;				
			}
		}
				
		if((PINC & (1 << PC7)) == 0) {		
			while((PINC & (1 << PC7)) == 0);
			if(led == 1)	// s-a apasat butonul corect		 
				return 1;				
			else{ // s-a apasat un buton gresit
				time = 1;
				continue;
			}
		}
		
		if((PINB & (1 << PB1)) == 0) {		
			while((PINB & (1 << PB1)) == 0);
			if(led == 2)  	// s-a apasat butonul corect
				return 1;				
			else{ // s-a apasat un buton gresit
				time = 1;	
				continue;	
			}		
		}
		
		if((PINB & (1 << PB2)) == 0) { 		
			while((PINB & (1 << PB2)) == 0);
			if(led == 3) 	// s-a apasat butonul corect
				return 1;
			else{
				time = 1;
				continue;
			}
		}
		
		if((PINC & (1 << PC3)) == 0) {		
			while((PINC & (1 << PC3)) == 0);
			if(led == 4) // s-a apasat butonul corect
				return 1;				
			else{ // s-a apasat un buton gresit
				time = 1;
				continue;
			}
		}
		
		if((PINC & (1 << PC4)) == 0) {	
			while((PINC & (1 << PC4)) == 0);
			if(led == 5) // s-a apasat butonul corect
				return 1;
			else{ // s-a apasat un buton gresit
				time = 1;
				continue;
			}
		}
		
		if((PINC & (1 << PC2)) == 0) {		
			while((PINC & (1 << PC2)) == 0); 
			if(led == 6)  // s-a apasat butonul corect
				return 1;
			else{ // s-a apasat un buton gresit
				time = 1;
				continue;
			}
		} 
		
		if((PINC & (1 << PC1)) == 0) {		 
			while((PINC & (1 << PC1)) == 0);
			if(led == 7)  	// s-a apasat butonul corect				
				return 1;
			else{ // s-a apasat un buton gresit
				time = 1;
				continue;
			}
		}
		
		if((PINC & (1 << PC5)) == 0) {		
			while((PINC & (1 << PC5)) == 0);
			if(led == 8) // s-a apasat butonul corect
				return 1;
			else{ // s-a apasat un buton gresit
				time = 1;
				continue;
			}
		}
		
	}
	return 0;
} 

void setup() {

	/* Speaker-ul este pus ca iesire */
    DDRD |= (1 << PD5);
	
	// setam leduri grad dificultate ca iesire
	DDRD |= (1 << PD0);
	PORTD &= ~(1 << PD0);
	
	DDRD |= (1 << PD1);
	PORTD &= ~(1 << PD1);
	
	DDRB |= (1 << PB3);
	PORTB &= ~(1 << PB3);
		
	// setam butonul start_game ca intrare
	DDRD &= ~(1 << PD6);
	PORTD |= (1 << PD6);
	
	// setam cele 9 butoane ca intrare si ledurile asociate ca iesire
	DDRB &= ~(1 << PB1);
	PORTB |= (1 << PB1);	
	DDRA |= (1 << PA2);
	PORTA &= ~(1 << PA2);
	
	DDRB &= ~(1 << PB2);
	PORTB |= (1 << PB2);	
	DDRA |= (1 << PA3);
	PORTA &= ~(1 << PA3);
	
	DDRC &= ~(1 << PC7);
	PORTC |= (1 << PC7);	
	DDRA |= (1 << PA1);
	PORTA &= ~(1 << PA1);
	
	DDRC &= ~(1 << PC6);
	PORTC |= (1 << PC6);		
	DDRA |= (1 << PA0);
	PORTA &= ~(1 << PA0);
	
	DDRC &= ~(1 << PC2);
	PORTC |= (1 << PC2);		
	DDRA |= (1 << PA6);
	PORTA &= ~(1 << PA6);
	
	DDRC &= ~(1 << PC4);
	PORTC |= (1 << PC4);		
	DDRA |= (1 << PA5);
	PORTA &= ~(1 << PA5);
	
	DDRC &= ~(1 << PC3);
	PORTC |= (1 << PC3);		
	DDRA |= (1 << PA4);
	PORTA &= ~(1 << PA4);
	
	DDRC &= ~(1 << PC1);
	PORTC |= (1 << PC1);		
	DDRA |= (1 << PA7);
	PORTA &= ~(1 << PA7);
	
	DDRC &= ~(1 << PC5);
	PORTC |= (1 << PC5);		
	DDRB |= (1 << PB0);
	PORTB &= ~(1 << PB0);
}

int main() {

	// in start_game se afla nr de apasari al butonului start game
	int start_game = 0;
	int begin = 0;
	int led, level = 0, time = 0;
	int seed = 0;

	// in correct se afla nr de apasari corecte de pe un nivel
	int correct = 0;	
	// in incorrect se afla nr de apasari incorecte de pe un nivel
	int incorrect = 0;
	
	// initializari
	setup();	
	
	while(1) {
	
		seed++;
		if(seed == 400)
			seed = 0;
		// Calculez de cate ori am apasat pe butonul de start game
		if((PIND & (1 << PD6)) == 0) {		
			start_game++;
		}
		
		if(begin == 0) {
			srand(seed);
			begin = 1;
		}
		
		if(start_game % 2 == 0){ // resetare joc
			setup();
			correct = 0;
			incorrect = 0;
			level = 0;
			begin = 0;
		}
		
		else{ // incepere joc

			if(incorrect == LOSE) { // jucatorul a pierdut
				start_game++;				
				setup();				
				loser_play();
			
			}
			else { // inca in joc
				if(level == LEVEL1) { // primul nivel de dificultate
					// aprindem primul led de dificultate
					PORTD |= (1 << PD0);
					_delay_ms(10);
					level = 1;
					between_levels_play();
				}
		
				if(correct == LEVEL2 && level == 1) { // trecem la al 2-lea nivel de dificultate
					PORTD &= ~(1 << PD0); // stingem primul led de dificultate
					PORTD |= (1 << PD1); // aprindem al doilea led de dificultate
					_delay_ms(10);
					level = 2;
					between_levels_play();
				}
			
				if(correct == LEVEL3 && level == 2) { // trecem la al 3-lea nivel de dificultate
					PORTD &= ~(1 << PD1); // stingem al doilea led de dificultate
					PORTB |= (1 << PB3); // aprindem al treilea led de dificultate					
					_delay_ms(10);
					level = 3;
					between_levels_play();
				}
			
				if(correct == WIN) { // jucatorul a castigat
					start_game++;				
					// stingem orice alt led aprins anterior
					PORTA = 0x00;
					PORTB &= ~(1 << PB0);
					// aprindem ledurile de dificultate
					PORTD |= (1 << PD1);
					PORTD |= (1 << PD0);
					PORTB |= (1 << PB3);
					winner_play();
				}
				else { // jocul inca continua
					led = choose_led();				
				
					// in functie de nivel jucatorul are un timp maxim pana cand trebuie sa apese
					// butonul corect
					int but;
					but = push_button(led, level) ;
					if(but == 1) {
						correct++;					
					}
					else {
						incorrect++;
						play_mistake();					
					}
				
					// in functie de nivel ledurile se aprind cu o anumita viteza
					if(level == 1){
						time = 60;
						while(time--)
							_delay_ms(5);
					}
					if(level == 2){
						time = 20;
						while(time--)
							_delay_ms(5);
					}	
					if(level == 3){
						time = 1;
						while(time--)
							_delay_ms(5);
					}
				}
			}
		}
	}

	return 0;

}

